(function (global, factory) {
    typeof exports === 'object' && typeof module !== 'undefined' ? factory(exports, require('@angular/cdk/coercion'), require('@angular/core'), require('@angular/animations'), require('@angular/forms'), require('@ng-tangram/animate/fading'), require('rxjs/add/observable/of'), require('rxjs/add/operator/distinctUntilChanged'), require('rxjs/Observable'), require('rxjs/observable/defer'), require('rxjs/operators'), require('rxjs/Subject'), require('@angular/common')) :
    typeof define === 'function' && define.amd ? define(['exports', '@angular/cdk/coercion', '@angular/core', '@angular/animations', '@angular/forms', '@ng-tangram/animate/fading', 'rxjs/add/observable/of', 'rxjs/add/operator/distinctUntilChanged', 'rxjs/Observable', 'rxjs/observable/defer', 'rxjs/operators', 'rxjs/Subject', '@angular/common'], factory) :
    (factory((global.nt = global.nt || {}, global.nt.components = global.nt.components || {}, global.nt.components.forms = {}),global.ng.cdk.coercion,global.ng.core,global.ng.animations,global.ng.forms,global.nt.animate.fading,null,null,global.Rx.Observable,global.Rx.observable.defer,global.Rx.operators,global.Rx.Subject,global.ng.common));
}(this, (function (exports,coercion,core,animations,forms,fading,of,distinctUntilChanged,Observable,defer,operators,Subject,common) { 'use strict';

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes} checked by tsc
     */
    /**
     * @license
     * Copyright Google LLC All Rights Reserved.
     *
     * Use of this source code is governed by an MIT-style license that can be
     * found in the LICENSE file at https://angular.io/license
     */
    /**
     * An interface which allows a control to work inside of a `NtFormField`.
     * @abstract
     * @template T
     */
    var  /**
     * An interface which allows a control to work inside of a `NtFormField`.
     * @abstract
     * @template T
     */
    NtFormFieldControl = /** @class */ (function () {
        function NtFormFieldControl() {
        }
        /**  */
        /**
         *
         * @return {?}
         */
        NtFormFieldControl.prototype.focus = /**
         *
         * @return {?}
         */
        function () { };
        return NtFormFieldControl;
    }());

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes} checked by tsc
     */
    var NtFormLabelWidthDirective = /** @class */ (function () {
        function NtFormLabelWidthDirective() {
            this.widthChange = new core.EventEmitter();
        }
        Object.defineProperty(NtFormLabelWidthDirective.prototype, "width", {
            get: /**
             * @return {?}
             */
            function () { return this._width || 120; },
            set: /**
             * @param {?} value
             * @return {?}
             */
            function (value) {
                this._width = coercion.coerceNumberProperty(value, 0);
                if (this._width > 0) {
                    this.widthChange.next(this._width);
                }
            },
            enumerable: true,
            configurable: true
        });
        /**
         * @return {?}
         */
        NtFormLabelWidthDirective.prototype.ngOnDestroy = /**
         * @return {?}
         */
        function () {
            this.widthChange.next();
            this.widthChange.complete();
        };
        NtFormLabelWidthDirective.decorators = [
            { type: core.Directive, args: [{
                        selector: 'form[ntFormLabelWidth]',
                    },] },
        ];
        /** @nocollapse */
        NtFormLabelWidthDirective.ctorParameters = function () { return []; };
        NtFormLabelWidthDirective.propDecorators = {
            "width": [{ type: core.Input, args: ['ntFormLabelWidth',] },],
        };
        return NtFormLabelWidthDirective;
    }());

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes} checked by tsc
     */
    var NtFormOrientationDirective = /** @class */ (function () {
        function NtFormOrientationDirective() {
            this.orientationChange = new core.EventEmitter();
        }
        Object.defineProperty(NtFormOrientationDirective.prototype, "orientation", {
            get: /**
             * @return {?}
             */
            function () { return this._orientation; },
            set: /**
             * @param {?} value
             * @return {?}
             */
            function (value) {
                this._orientation = value;
                this.orientationChange.next(this._orientation);
            },
            enumerable: true,
            configurable: true
        });
        /**
         * @return {?}
         */
        NtFormOrientationDirective.prototype.ngOnDestroy = /**
         * @return {?}
         */
        function () {
            this.orientationChange.next();
            this.orientationChange.complete();
        };
        NtFormOrientationDirective.decorators = [
            { type: core.Directive, args: [{
                        selector: 'form[ntFormOrientation]',
                    },] },
        ];
        /** @nocollapse */
        NtFormOrientationDirective.ctorParameters = function () { return []; };
        NtFormOrientationDirective.propDecorators = {
            "orientation": [{ type: core.Input, args: ['ntFormOrientation',] },],
        };
        return NtFormOrientationDirective;
    }());

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes} checked by tsc
     */
    var NtFormFieldComponent = /** @class */ (function () {
        function NtFormFieldComponent(_ngZone, _changeDetectorRef, _parentForm, _parentFormGroup, _formLabelWidth, _formOrientation) {
            var _this = this;
            this._ngZone = _ngZone;
            this._changeDetectorRef = _changeDetectorRef;
            this._parentForm = _parentForm;
            this._parentFormGroup = _parentFormGroup;
            this._formLabelWidth = _formLabelWidth;
            this._formOrientation = _formOrientation;
            this._destroy = new Subject.Subject();
            /**
             * 表单可见性
             */
            this._labelVisible = true;
            this._selfLabelWidth = false;
            this._selfOrientation = false;
            /**
             * 表单宽度 （只在 horizontal 模式下起作用）
             */
            this._labelStyles = {};
            this._groupStyles = {};
            this._invalid = false;
            this.statusChanges = defer.defer(function () {
                if (_this.control && _this.ngControl) {
                    return _this.ngControl.statusChanges ? _this.ngControl.statusChanges : Observable.Observable.of(null);
                }
                return _this._ngZone.onStable
                    .asObservable()
                    .pipe(operators.take(1), operators.switchMap(function () { return _this.statusChanges; }));
            });
            if (_formLabelWidth) {
                _formLabelWidth.widthChange.pipe(operators.takeUntil(this._destroy), operators.filter(function () { return !_this._selfLabelWidth; }))
                    .subscribe(function (width) {
                    _this._labelWidth = width;
                    _this._setHorizontalStyles();
                });
            }
            if (_formOrientation) {
                _formOrientation.orientationChange.pipe(operators.takeUntil(this._destroy), operators.filter(function () { return !_this._selfOrientation; }))
                    .subscribe(function (orientation) {
                    _this._orientation = orientation;
                    _this._setHorizontalStyles();
                });
            }
            this.statusChanges.pipe(operators.takeUntil(this._destroy)).subscribe(function () { return _this._validate(); });
        }
        Object.defineProperty(NtFormFieldComponent.prototype, "labelVisible", {
            get: /**
             * @return {?}
             */
            function () { return this._labelVisible; },
            set: /**
             * @param {?} value
             * @return {?}
             */
            function (value) { this._labelVisible = coercion.coerceBooleanProperty(value); },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(NtFormFieldComponent.prototype, "labelWidth", {
            get: /**
             * @return {?}
             */
            function () { return this._labelWidth || 120; },
            set: /**
             * @param {?} value
             * @return {?}
             */
            function (value) {
                this._labelWidth = coercion.coerceNumberProperty(value, 0);
                this._selfLabelWidth = this._labelWidth > 0;
                this._setHorizontalStyles();
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(NtFormFieldComponent.prototype, "orientation", {
            get: /**
             * @return {?}
             */
            function () { return this._orientation; },
            set: /**
             * @param {?} value
             * @return {?}
             */
            function (value) {
                this._orientation = value;
                this._selfOrientation = true;
                this._setHorizontalStyles();
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(NtFormFieldComponent.prototype, "horizontal", {
            get: /**
             * @return {?}
             */
            function () { return this.orientation === 'horizontal'; },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(NtFormFieldComponent.prototype, "required", {
            get: /**
             * @return {?}
             */
            function () {
                if (this.ngControl &&
                    this.ngControl.control &&
                    this.ngControl.control.validator) {
                    var /** @type {?} */ control = new forms.FormControl();
                    var /** @type {?} */ validateResult = this.ngControl.control.validator(control);
                    return validateResult && validateResult.hasOwnProperty('required');
                }
                if (this.control) {
                    return !!this.control.required;
                }
                return false;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(NtFormFieldComponent.prototype, "errors", {
            get: /**
             * @return {?}
             */
            function () { return this.control.ngControl ? this.control.ngControl.errors : null; },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(NtFormFieldComponent.prototype, "ngSubmit", {
            get: /**
             * @return {?}
             */
            function () {
                if (this._parentForm || this._parentFormGroup) {
                    return (this._parentForm || this._parentFormGroup || /** @type {?} */ ({})).ngSubmit;
                }
                return null;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(NtFormFieldComponent.prototype, "ngControl", {
            get: /**
             * @return {?}
             */
            function () { return this.control ? this.control.ngControl : null; },
            enumerable: true,
            configurable: true
        });
        /**
         * @return {?}
         */
        NtFormFieldComponent.prototype.ngAfterViewInit = /**
         * @return {?}
         */
        function () {
            var _this = this;
            if (this.ngSubmit && this.ngControl) {
                this.ngSubmit.pipe(operators.takeUntil(this._destroy)).subscribe(function () { return _this._validate(); });
            }
        };
        /**
         * @return {?}
         */
        NtFormFieldComponent.prototype.ngOnDestroy = /**
         * @return {?}
         */
        function () {
            this._destroy.next();
            this._destroy.complete();
        };
        /**
         * @return {?}
         */
        NtFormFieldComponent.prototype._validate = /**
         * @return {?}
         */
        function () {
            if (this.ngControl) {
                this._invalid = !!this.ngControl.invalid;
                this._changeDetectorRef.markForCheck();
            }
        };
        /**
         * @return {?}
         */
        NtFormFieldComponent.prototype._setHorizontalStyles = /**
         * @return {?}
         */
        function () {
            if (this.labelWidth > 0 && this.horizontal) {
                this._labelStyles['width.px'] = this.labelWidth;
                this._groupStyles['margin-left.px'] = this.labelWidth;
            }
            else {
                delete this._labelStyles['width.px'];
                delete this._groupStyles['margin-left.px'];
            }
        };
        NtFormFieldComponent.decorators = [
            { type: core.Component, args: [{
                        selector: 'nt-form-field',
                        template: "\n    <label class=\"nt-form-label\" [ngStyle]=\"_labelStyles\" [class.required]=\"required\" *ngIf=\"labelVisible\">{{label}}</label>\n    <div class=\"nt-form-group\" [ngStyle]=\"_groupStyles\">\n      <div class=\"nt-form-control\">\n        <ng-content></ng-content>\n      </div>\n      <span class=\"form-error is-visible\" *ngIf=\"_invalid && errors\" [@fade]=\"_invalid\">\n        {{ errors | ntFormError:label:messages }}\n      </span>\n    </div>\n  ",
                        animations: [
                            animations.trigger('fade', [
                                animations.transition('* => false', fading.fadeOut(.15)),
                                animations.transition('* => true', fading.fadeIn(.15))
                            ])
                        ],
                        encapsulation: core.ViewEncapsulation.None,
                        changeDetection: core.ChangeDetectionStrategy.OnPush,
                        host: {
                            'class': 'nt-form-field',
                            '[class.nt-form-error]': '_invalid',
                            '[class.nt-form-horizontal]': 'horizontal'
                        }
                    },] },
        ];
        /** @nocollapse */
        NtFormFieldComponent.ctorParameters = function () { return [
            { type: core.NgZone, },
            { type: core.ChangeDetectorRef, },
            { type: forms.NgForm, decorators: [{ type: core.Optional },] },
            { type: forms.FormGroupDirective, decorators: [{ type: core.Optional },] },
            { type: NtFormLabelWidthDirective, decorators: [{ type: core.Optional },] },
            { type: NtFormOrientationDirective, decorators: [{ type: core.Optional },] },
        ]; };
        NtFormFieldComponent.propDecorators = {
            "label": [{ type: core.Input },],
            "labelVisible": [{ type: core.Input },],
            "labelWidth": [{ type: core.Input },],
            "messages": [{ type: core.Input },],
            "orientation": [{ type: core.Input },],
            "control": [{ type: core.ContentChild, args: [NtFormFieldControl,] },],
        };
        return NtFormFieldComponent;
    }());

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes} checked by tsc
     */
    var NtFormAutofocusDirective = /** @class */ (function () {
        function NtFormAutofocusDirective(form, formGroup) {
            this._form = form || formGroup;
        }
        /**
         * @return {?}
         */
        NtFormAutofocusDirective.prototype.onSubmit = /**
         * @return {?}
         */
        function () {
            if (this._form.invalid) {
                var /** @type {?} */ field = this.fields.find(function (field) { return !!field.ngControl && !!field.ngControl.invalid; });
                if (field && field.control) {
                    field.control.focus();
                }
            }
        };
        NtFormAutofocusDirective.decorators = [
            { type: core.Directive, args: [{
                        selector: 'form[ntFormAutofocus]',
                        host: {
                            '(submit)': 'onSubmit($event)'
                        }
                    },] },
        ];
        /** @nocollapse */
        NtFormAutofocusDirective.ctorParameters = function () { return [
            { type: forms.NgForm, decorators: [{ type: core.Optional },] },
            { type: forms.FormGroupDirective, decorators: [{ type: core.Optional },] },
        ]; };
        NtFormAutofocusDirective.propDecorators = {
            "fields": [{ type: core.ContentChildren, args: [NtFormFieldComponent,] },],
        };
        return NtFormAutofocusDirective;
    }());

    /*! *****************************************************************************
    Copyright (c) Microsoft Corporation. All rights reserved.
    Licensed under the Apache License, Version 2.0 (the "License"); you may not use
    this file except in compliance with the License. You may obtain a copy of the
    License at http://www.apache.org/licenses/LICENSE-2.0

    THIS CODE IS PROVIDED ON AN *AS IS* BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY
    KIND, EITHER EXPRESS OR IMPLIED, INCLUDING WITHOUT LIMITATION ANY IMPLIED
    WARRANTIES OR CONDITIONS OF TITLE, FITNESS FOR A PARTICULAR PURPOSE,
    MERCHANTABLITY OR NON-INFRINGEMENT.

    See the Apache Version 2.0 License for specific language governing permissions
    and limitations under the License.
    ***************************************************************************** */

    var __assign = Object.assign || function __assign(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p)) t[p] = s[p];
        }
        return t;
    };

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes} checked by tsc
     */
    var /** @type {?} */ DEFAULT_TEMPLATES = {
        "required": "请填写{0}",
        "email": "{0}不是邮箱格式",
        "min": "{0}必须输入大于{1}的数字",
        "max": "{0}必须输入小于{1}的数字",
        "pattern": "{0}不是合法的数据",
        "maxlength": "{0}长度为最大{1}",
        "minlength": "{0}长度为最小{1}"
    };
    var NtFormValidationTransformer = /** @class */ (function () {
        function NtFormValidationTransformer() {
        }
        /**
         * @param {?=} errors
         * @param {?=} label
         * @param {?=} messages
         * @return {?}
         */
        NtFormValidationTransformer.prototype.transform = /**
         * @param {?=} errors
         * @param {?=} label
         * @param {?=} messages
         * @return {?}
         */
        function (errors, label, messages) {
            if (!errors) {
                return '';
            }
            var /** @type {?} */ templates = __assign({}, DEFAULT_TEMPLATES, messages);
            if (errors.hasOwnProperty('required')) {
                return this._format(templates['required'], label);
            }
            else if (errors.hasOwnProperty('email')) {
                return this._format(templates['email'], label);
            }
            else if (errors.hasOwnProperty('min')) {
                return this._format(templates['min'], label, errors["min"].min);
            }
            else if (errors.hasOwnProperty('max')) {
                return this._format(templates['max'], label, errors["max"].max);
            }
            else if (errors.hasOwnProperty('minlength')) {
                return this._format(templates['minlength'], label, errors["minlength"].requiredLength);
            }
            else if (errors.hasOwnProperty('maxlength')) {
                return this._format(templates['maxlength'], label, errors["maxlength"].requiredLength);
            }
            else if (errors.hasOwnProperty('pattern')) {
                return this._format(templates['pattern'], label);
            }
            else {
                return '';
            }
        };
        /**
         * @param {?} template
         * @param {...?} args
         * @return {?}
         */
        NtFormValidationTransformer.prototype._format = /**
         * @param {?} template
         * @param {...?} args
         * @return {?}
         */
        function (template) {
            var args = [];
            for (var _i = 1; _i < arguments.length; _i++) {
                args[_i - 1] = arguments[_i];
            }
            return template.replace(/\{(\d+)\}/g, function (match, number) {
                return typeof args[number] !== 'undefined' ? args[number] : match;
            });
        };
        NtFormValidationTransformer.decorators = [
            { type: core.Injectable },
        ];
        /** @nocollapse */
        NtFormValidationTransformer.ctorParameters = function () { return []; };
        return NtFormValidationTransformer;
    }());
    // export const NT_VALIDATION_TEMPLATE = new InjectionToken<NtValidationTemplate>('nt-validation-template');
    var /** @type {?} */ NT_VALIDATION_TRANSFOMER = new core.InjectionToken('nt-validation-transformer');

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes} checked by tsc
     */
    var NtFormErrorPipe = /** @class */ (function () {
        function NtFormErrorPipe(_transformer) {
            this._transformer = _transformer;
        }
        /**
         * @param {?} value
         * @param {...?} args
         * @return {?}
         */
        NtFormErrorPipe.prototype.transform = /**
         * @param {?} value
         * @param {...?} args
         * @return {?}
         */
        function (value) {
            var args = [];
            for (var _i = 1; _i < arguments.length; _i++) {
                args[_i - 1] = arguments[_i];
            }
            return (_a = this._transformer).transform.apply(_a, [value].concat(args));
            var _a;
        };
        NtFormErrorPipe.decorators = [
            { type: core.Pipe, args: [{ name: 'ntFormError' },] },
        ];
        /** @nocollapse */
        NtFormErrorPipe.ctorParameters = function () { return [
            { type: undefined, decorators: [{ type: core.Inject, args: [NT_VALIDATION_TRANSFOMER,] },] },
        ]; };
        return NtFormErrorPipe;
    }());

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes} checked by tsc
     */
    var NtFormsModule = /** @class */ (function () {
        function NtFormsModule() {
        }
        /**
         * @param {?=} transformer
         * @return {?}
         */
        NtFormsModule.forRoot = /**
         * @param {?=} transformer
         * @return {?}
         */
        function (transformer) {
            return {
                ngModule: NtFormsModule,
                providers: [
                    { provide: NT_VALIDATION_TRANSFOMER, useClass: transformer || NtFormValidationTransformer }
                ]
            };
        };
        NtFormsModule.decorators = [
            { type: core.NgModule, args: [{
                        imports: [common.CommonModule],
                        exports: [
                            NtFormFieldComponent,
                            NtFormAutofocusDirective,
                            NtFormLabelWidthDirective,
                            NtFormOrientationDirective,
                            NtFormErrorPipe
                        ],
                        declarations: [
                            NtFormFieldComponent,
                            NtFormAutofocusDirective,
                            NtFormLabelWidthDirective,
                            NtFormOrientationDirective,
                            NtFormErrorPipe
                        ]
                    },] },
        ];
        /** @nocollapse */
        NtFormsModule.ctorParameters = function () { return []; };
        return NtFormsModule;
    }());

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes} checked by tsc
     */

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes} checked by tsc
     */

    exports.NtFormsModule = NtFormsModule;
    exports.NtFormErrorPipe = NtFormErrorPipe;
    exports.NtFormFieldComponent = NtFormFieldComponent;
    exports.NtFormFieldControl = NtFormFieldControl;
    exports.NtFormAutofocusDirective = NtFormAutofocusDirective;
    exports.NtFormLabelWidthDirective = NtFormLabelWidthDirective;
    exports.NtFormOrientationDirective = NtFormOrientationDirective;
    exports.DEFAULT_TEMPLATES = DEFAULT_TEMPLATES;
    exports.NtFormValidationTransformer = NtFormValidationTransformer;
    exports.NT_VALIDATION_TRANSFOMER = NT_VALIDATION_TRANSFOMER;

    Object.defineProperty(exports, '__esModule', { value: true });

})));
//# sourceMappingURL=forms.umd.js.map
